/*------------------------------------------------------------------------
# Joomla Carousel Module by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# Copyright (C) 2010 - 2012 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomshaper.com
-------------------------------------------------------------------------*/
// iCarousel is an open source (free) javascript tool for creating carousel like widgets. Copyright (c) 2007 Fabio Zendhi Nagao, http://zend.lojcomm.com.br/icarousel/, MIT Style License.
var iCarousel = new Class({
    options: {
        animation: {
            type: "fadeNscroll",
            direction: "left",
            amount: 1,
            transition: Fx.Transitions.Cubic.easeInOut,
            duration: 500,
            rotate: {
                type: "manual",
                interval: 5000,
                onMouseOver: "stop"
            }
        },
        item: {
            klass: "item",
            size: 100
        },
        idPrevious: "previous",
        idNext: "next",
        idToggle: "toggle",
        onClickPrevious: Class.empty,
        onClickNext: Class.empty,
        onPrevious: Class.empty,
        onNext: Class.empty,
        onGoTo: Class.empty
    },
    initialize: function (c, b) {
        this.setOptions(b);
        this.container = $(c);
        this.aItems = $$('.' + this.options.item.klass);
        this.isMouseOver = false;
        if (this.options.idPrevious != "undefined" && $(this.options.idPrevious)) $(this.options.idPrevious).addEvent("click", function (event) {
            event.stop();
            this._3();
            this.fireEvent("onClickPrevious", this, 20)
        }.bind(this));
        if (this.options.idNext != "undefined" && $(this.options.idNext)) $(this.options.idNext).addEvent("click", function (event) {
             event.stop();
            this._2();
            this.fireEvent("onClickNext", this, 20)
        }.bind(this));
        if (this.options.idToggle != "undefined" && $(this.options.idToggle)) $(this.options.idToggle).addEvent("click", function (event) {
             event.stop();
            this._4()
        }.bind(this));
        var d = this.options.animation;
        switch (this.options.animation.type.toLowerCase()) {
        case "fade":
            this.aItems.each(function (a) {
                a.fx = a.effect("opacity", {
                    duration: d.duration,
                    transition: d.transition
                });
                a.setStyle("opacity", 0);
                a.addEvents({
                    "mouseenter": function () {
                        this.isMouseOver = true;
                        if (this.options.animation.rotate.type == "auto") this.timer = $clear(this.timer)
                    }.bind(this),
                    "mouseleave": function () {
                        this.isMouseOver = false;
                        if (this.options.animation.rotate.type == "auto") this.timer = this._1.periodical(this.options.animation.rotate.interval, this)
                    }.bind(this)
                })
            }.bind(this));
            this.height = this.container.getStyle("height").toInt();
            this.atScreen = 0;
            this._0(this.atScreen);
            break;
        default:
            (2).times(function () {
                this.aItems.each(function (a) {
                    a.clone().inject(this.container, 'inside')
                }.bind(this))
            }.bind(this));
            this.aItems = $$('.' + this.options.item.klass);
            this.aItems.each(function (a) {
                a.addEvents({
                    "mouseenter": function () {
                        this.isMouseOver = true;
                        if (this.options.animation.rotate.type == "auto") this.timer = $clear(this.timer)
                    }.bind(this),
                    "mouseleave": function () {
                        this.isMouseOver = false;
                        if (this.options.animation.rotate.type == "auto") this.timer = this._1.periodical(this.options.animation.rotate.interval, this)
                    }.bind(this)
                })
            }.bind(this));
            this.fx = new Fx.Morph(this.container, {
                duration: d.duration,
                transition: d.transition,
                wait: false
            });
            this.atScreen = this.aItems.length / 3;
            this.container.setStyle(d.direction, -this.atScreen * this.options.item.size);
            break
        }
        if (this.options.animation.rotate.type == "auto") this.timer = this._1.periodical(this.options.animation.rotate.interval, this)
    },
    goTo: function (a) {
        switch (this.options.animation.type.toLowerCase()) {
        case "fade":
            var c = this.atScreen;
            this.atScreen = Math.abs(a % (this.aItems.length / 3));
            this._0(this.atScreen, c);
            break;
        default:
            this.atScreen = Math.abs(a % (this.aItems.length / 3));
            this.atScreen += this.aItems.length / 3;
            this._0(this.atScreen);
            break
        }
        this.fireEvent("onGoTo", this, 20)
    },
    _3: function () {
        switch (this.options.animation.type.toLowerCase()) {
        case "fade":
            var a = this.atScreen;
            this.atScreen -= this.options.animation.amount;
            if (this.atScreen < 0) this.atScreen = (this.aItems.length - 1);
            this._0(this.atScreen, a);
            break;
        default:
            this.atScreen -= this.options.animation.amount;
            if (this.atScreen < this.aItems.length / 3) {
                this.container.setStyle(this.options.animation.direction, -this.options.item.size * this.aItems.length * 2 / 3);
                this.atScreen = this.aItems.length * 2 / 3 - this.options.animation.amount
            }
            this._0(this.atScreen);
            break
        }
        this.fireEvent("onPrevious", this, 20)
    },
    _2: function () {
        switch (this.options.animation.type.toLowerCase()) {
        case "fade":
            var a = this.atScreen;
            this.atScreen += this.options.animation.amount;
            if (this.atScreen >= this.aItems.length) this.atScreen = 0;
            this._0(this.atScreen, a);
            break;
        default:
            this.atScreen += this.options.animation.amount;
            if (this.atScreen > this.aItems.length * 2 / 3) {
                this.container.setStyle(this.options.animation.direction, -this.options.item.size * this.aItems.length / 3);
                this.atScreen = this.aItems.length / 3 + this.options.animation.amount
            }
            this._0(this.atScreen);
            break
        }
        this.fireEvent("onNext", this, 20)
    },
    _4: function () {
        (this.container.getStyle("height").toInt() == 0) ? this.container.effect("height", {
            duration: 1000,
            transition: Fx.Transitions.Sine.easeInOut
        }).start(this.height) : this.container.effect("height", {
            duration: 1000,
            transition: Fx.Transitions.Sine.easeInOut
        }).start(0)
    },
    _1: function () {
        if (this.options.animation.rotate.onMouseOver == "stop" && !this.isMouseOver) this._2()
    },
    _0: function (a, c) {
        switch (this.options.animation.type) {
        case "fade":
            if ($defined(c)) {
                this.aItems[c].fx.start(0).chain(function () {
                    this.aItems[a].fx.start(1)
                }.bind(this))
            } else {
                this.aItems[a].fx.start(1)
            }
            break;
        case "scroll":
            var b = this;
            if (b.options.animation.direction == "top") {
                b.fx.start({
                    "top": -a * b.options.item.size
                })
            } else {
                b.fx.start({
                    "left": -a * b.options.item.size
                })
            }
            break;
        case "fadeNscroll":
            var b = this;
            if (b.options.animation.direction == "top") {
                b.fx.start({
                    "opacity": 0.75
                }).chain(function () {
                    b.fx.start({
                        "top": -a * b.options.item.size
                    }).chain(function () {
                        b.fx.start({
                            "opacity": 1
                        })
                    })
                })
            } else {
                b.fx.start({
                    "opacity": 0.75
                }).chain(function () {
                    b.fx.start({
                        "left": -a * b.options.item.size
                    }).chain(function () {
                        b.fx.start({
                            "opacity": 1
                        })
                    })
                })
            }
            break
        }
    }
});
iCarousel.implement(new Events);
iCarousel.implement(new Options);