<?php
/*------------------------------------------------------------------------
# Joomla Carousel Module by JoomShaper.com based on iCarousel
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# copyright Copyright (C) 2010 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomshaper.com - http://www.joomxpert.com
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modCarouselHelper
{		
	function getList(&$params){
		
		global $mainframe;
		
		$cparams	    = & $mainframe->getParams('com_content');

		$db			    = & JFactory::getDBO();
		$user		    = & JFactory::getUser();
		$userId		    = (int) $user->get('id');
		
		$count		    = $params->get('count',5); 
		$catid		    = $params->get('catid');
		$show_fp	    = $params->get('show_front', 1);
		$aid		    = $user->get('aid', 0);
		$ordering       = $params->get('itemsOrdering');
		$user_id        = $params->get('user_id');
		
		$contentConfig  = &JComponentHelper::getParams( 'com_content' );
		$access		    = !$contentConfig->get('shownoauth');

		$nullDate	    = $db->getNullDate();

		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		$where = '';
		
		// User Filter
		switch ($user_id)
		{
			case 'by_me':
				$where .= ' AND (a.created_by = ' . (int) $userId . ' OR a.modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (a.created_by <> ' . (int) $userId . ' AND a.modified_by <> ' . (int) $userId . ')';
				break;
		}
		
		// ensure should be published
		$where .= " AND ( a.publish_up = ".$db->Quote($nullDate)." OR a.publish_up <= ".$db->Quote($now)." )";
		$where .= " AND ( a.publish_down = ".$db->Quote($nullDate)." OR a.publish_down >= ".$db->Quote($now)." )";
		
	    // ordering
		switch ($ordering) {
			case 'date' :
				$orderby = 'a.created ASC';
				break;
			case 'rdate' :
				$orderby = 'a.created DESC';
				break;
			case 'alpha' :
				$orderby = 'a.title';
				break;
			case 'ralpha' :
				$orderby = 'a.title DESC';
				break;
			case 'order' :
				$orderby = 'a.ordering';
				break;
			default :
				$orderby = 'a.id DESC';
				break;
		}
		
            
		$catCondition = '';

		if ($show_fp != 2) {
			if ($catid)
			{
				if (is_array($catid)) {
					$jcids = implode($catid,',');	
					$ids = explode( ',', $jcids );
				} else {
					$ids = explode( ',', $catid );
				}
				
				JArrayHelper::toInteger( $ids );
				$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
			}
		}
	
		// Content Items only
		$query = 'SELECT a.*, ' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			($show_fp == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			($show_fp == '2' ? ' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE a.state = 1'. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			($catid && $show_fp != 2 ? $catCondition : '').
			($show_fp == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $orderby;
			
		$db->setQuery($query, 0, $count);

		$rows = $db->loadObjectList();

        $i=0;
		$lists	= array();
		
		if (is_array($rows) && count($rows)>0) {
    		foreach ( $rows as $row )
    		{
				$lists[$i]->image		= modCarouselHelper::getImage($row->introtext);
				$lists[$i]->link 		= JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
    			$i++;
    		}
        }
		return $lists;
	}
	
	function getImage($text) {
		preg_match("/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/", $text, $matches);
		
		if (!isset($matches[1])) { 
			$matches[1]='modules/mod_shaper_carousel/assets/no-image.jpg';
		}
		
		if (!file_exists($matches[1])) {
			$matches[1]='modules/mod_shaper_carousel/assets/no-image.jpg';
		}	
		
		if (isset($matches[1])) {
			$image_name	= $matches[1];
		}
		
		return $image_name;
	}
	
	function getImageList(&$params) {
		jimport( 'joomla.filesystem.folder' );
		$filter 	= '\.png$|\.gif$|\.jpg$|\.bmp$';
		$path		= $params->get('path');
		$files 		= JFolder::files(JPATH_BASE.$path,$filter);
		
		$i=0;
		$lists = array();
		
		foreach ($files as $file) {
			$lists[$i]->image	= JURI::base().str_replace(DS,'/',substr($path,1)).'/'.$file;
			$lists[$i]->link	= 'javascript:;';
			$i++;
		}
		return $lists; 
	}
}
 